/*
 
  guess6Decomp.cc

  author: Jim Fix, from code provided by the Reed CS2 course.

  This is a highly decomposed solution to Homework 01 Exercise 1. It
  illustrates the structure of a basic C++ program, using procedures
  and functions.

  The code plays a guessing game with its user, one where they have a
  limited number of guesses (six).

  I've, however, elided the bodies of its "helper" functions and 
  procedures. Finish their code and get this working!

*/

#include <iostream>
#include <ctime>    // For time()
#include <cstdlib>  // For srand() and rand()

// randomInt: generate a random number within a range
//
// low:  lowest number possible in range
// high: highest number possible in range
//
int randomInt(int low, int high) {
  return (rand() % (high - low + 1)) + low;
}

// assessGuess - helper function for `playGame`, just below
//
// Outputs some text indicate the quality of a player's guess.
//
// guess:  the number they guessed
// target: the number they were supposed to guess
//
// Returns whether their guess was correct.
//
bool assessGuess(int guess, int target) {

  // Your code here.
  //
  
  return false;
}

// promptForGuess - helper function for `playGame`, just below
//
// Outputs a proper prompt for a guess based on which attempt
// they are on (first, last, or neither)
//
// tries: number of attempts they've made so far
// bound: number of tries they get
//
void promptForGuess(int tries, int bound) {
  //
  // Your code here.
  //
}

// playGame - plays a guessing game
//
// number: the number that a player must guess
// bound:  the number of tries they're allowed
//
// returns whether they won the game
//
bool playGame(int number, int bound) {
  bool success = false;

  // Your code here.

  return success;
}

int main(void) {
  // pick a number
  srand(time(0));
  int number = randomInt(1,100);
  
  // give instructions
  std::cout << "I've chosen a number from 1 to 100. ";
  std::cout << "Try to guess what it is.\n";

  // play the game
  bool theyWon = playGame(number,6);

  // congratulate or taunt
  if (theyWon) {
    std::cout << "Well done! ";
  } else {
    std::cout << "Sorry, you are out of guesses...\n";
  }
  std::cout << number << " was the number I chose.\n";

  return 0;
}
